## quickshell 0.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(quickshell VERSION "0.2.1" LANGUAGES CXX C)

set(QT_MIN_VERSION "6.6.0")
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(QS_BUILD_OPTIONS "")

function(boption VAR NAME DEFAULT)
	cmake_parse_arguments(PARSE_ARGV 3 arg "" "REQUIRES" "")

	option(${VAR} ${NAME} ${DEFAULT})

	set(STATUS "${VAR}_status")
	set(EFFECTIVE "${VAR}_effective")
	set(${STATUS} ${${VAR}})
	set(${EFFECTIVE} ${${VAR}})

	if (${${VAR}} AND DEFINED arg_REQUIRES)
		set(REQUIRED_EFFECTIVE "${arg_REQUIRES}_effective")
		if (NOT ${${REQUIRED_EFFECTIVE}})
			set(${STATUS} "OFF (Requires ${arg_REQUIRES})")
			set(${EFFECTIVE} OFF)
		endif()
	endif()

	set(${EFFECTIVE} "${${EFFECTIVE}}" PARENT_SCOPE)

	message(STATUS "  ${NAME}: ${${STATUS}}")

	string(APPEND QS_BUILD_OPTIONS "\\n  ${NAME}: ${${STATUS}}")
	set(QS_BUILD_OPTIONS "${QS_BUILD_OPTIONS}" PARENT_SCOPE)
endfunction()

set(DISTRIBUTOR "Unset" CACHE STRING "Distributor")
string(APPEND QS_BUILD_OPTIONS "  Distributor: ${DISTRIBUTOR}")

message(STATUS "Quickshell configuration")
message(STATUS "  Distributor: ${DISTRIBUTOR}")
boption(DISTRIBUTOR_DEBUGINFO_AVAILABLE "Distributor provided debuginfo" NO)
boption(NO_PCH "Disable precompild headers (dev)" OFF)
boption(BUILD_TESTING "Build tests (dev)" OFF)
boption(ASAN "ASAN (dev)" OFF) # note: better output with gcc than clang
boption(FRAME_POINTERS "Keep Frame Pointers (dev)" ${ASAN})

boption(CRASH_REPORTER "Crash Handling" ON)
boption(USE_JEMALLOC "Use jemalloc" ON)
boption(SOCKETS "Unix Sockets" ON)
boption(WAYLAND "Wayland" ON)
boption(WAYLAND_WLR_LAYERSHELL "  Wlroots Layer-Shell" ON REQUIRES WAYLAND)
boption(WAYLAND_SESSION_LOCK "  Session Lock" ON REQUIRES WAYLAND)
boption(WAYLAND_TOPLEVEL_MANAGEMENT "  Foreign Toplevel Management" ON REQUIRES WAYLAND)
boption(HYPRLAND "  Hyprland" ON REQUIRES WAYLAND)
boption(HYPRLAND_IPC "    Hyprland IPC" ON REQUIRES HYPRLAND)
boption(HYPRLAND_GLOBAL_SHORTCUTS "    Hyprland Global Shortcuts" ON REQUIRES HYPRLAND)
boption(HYPRLAND_FOCUS_GRAB "    Hyprland Focus Grabbing" ON REQUIRES HYPRLAND)
boption(HYPRLAND_SURFACE_EXTENSIONS "    Hyprland Surface Extensions" ON REQUIRES HYPRLAND)
boption(SCREENCOPY "  Screencopy" ON REQUIRES WAYLAND)
boption(SCREENCOPY_ICC "    Image Copy Capture" ON REQUIRES WAYLAND)
boption(SCREENCOPY_WLR "    Wlroots Screencopy" ON REQUIRES WAYLAND)
boption(SCREENCOPY_HYPRLAND_TOPLEVEL "    Hyprland Toplevel Export" ON REQUIRES WAYLAND)
boption(X11 "X11" ON)
boption(I3 "I3/Sway" ON)
boption(I3_IPC "  I3/Sway IPC" ON REQUIRES I3)
boption(SERVICE_STATUS_NOTIFIER "System Tray" ON)
boption(SERVICE_PIPEWIRE "PipeWire" ON)
boption(SERVICE_MPRIS "Mpris" ON)
boption(SERVICE_PAM "Pam" ON)
boption(SERVICE_GREETD "Greetd" ON)
boption(SERVICE_UPOWER "UPower" ON)
boption(SERVICE_NOTIFICATIONS "Notifications" ON)
boption(BLUETOOTH "Bluetooth" ON)

include(cmake/install-qml-module.cmake)
include(cmake/util.cmake)

add_compile_options(-Wall -Wextra -Wno-vla-cxx-extension)

# pipewire defines this, breaking PCH
add_compile_definitions(_REENTRANT)

if (FRAME_POINTERS)
	add_compile_options(-fno-omit-frame-pointer)
endif()

if (ASAN)
	add_compile_options(-fsanitize=address)
	add_link_options(-fsanitize=address)
endif()

# nix workaround
if (CMAKE_EXPORT_COMPILE_COMMANDS)
	set(CMAKE_CXX_STANDARD_INCLUDE_DIRECTORIES ${CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES})
endif()

if (NOT CMAKE_BUILD_TYPE)
	message(STATUS "CMAKE_BUILD_TYPE unset, defaulting to Debug.")
	set(CMAKE_BUILD_TYPE Debug)
endif()

set(QT_FPDEPS Gui Qml Quick QuickControls2 Widgets ShaderTools)
set(QT_PRIVDEPS QuickPrivate)

include(cmake/pch.cmake)

if (BUILD_TESTING)
	enable_testing()
	add_definitions(-DQS_TEST)
	list(APPEND QT_FPDEPS Test)
endif()

if (SOCKETS)
	list(APPEND QT_FPDEPS Network)
endif()

if (WAYLAND)
	list(APPEND QT_FPDEPS WaylandClient)
	list(APPEND QT_PRIVDEPS WaylandClientPrivate)
endif()

if (SERVICE_STATUS_NOTIFIER OR SERVICE_MPRIS OR SERVICE_UPOWER OR SERVICE_NOTIFICATIONS OR BLUETOOTH)
	set(DBUS ON)
endif()

if (DBUS)
	list(APPEND QT_FPDEPS DBus)
endif()

find_package(Qt6 REQUIRED COMPONENTS ${QT_FPDEPS})

# In Qt 6.10, private dependencies are required to be explicit,
# but they could not be explicitly depended on prior to 6.9.
if (Qt6_VERSION VERSION_GREATER_EQUAL "6.9.0")
	set(QT_NO_PRIVATE_MODULE_WARNING ON)
	find_package(Qt6 REQUIRED COMPONENTS ${QT_PRIVDEPS})
endif()

set(CMAKE_AUTOUIC OFF)
qt_standard_project_setup(REQUIRES 6.6)
set(QT_QML_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/qml_modules)

add_subdirectory(src)

if (USE_JEMALLOC)
	find_package(PkgConfig REQUIRED)
	# IMPORTED_TARGET not working for some reason
	pkg_check_modules(JEMALLOC REQUIRED jemalloc)
	target_link_libraries(quickshell PRIVATE ${JEMALLOC_LIBRARIES})
endif()

install(CODE "
	execute_process(
		COMMAND ${CMAKE_COMMAND} -E create_symlink \
		${CMAKE_INSTALL_FULL_BINDIR}/quickshell \$ENV{DESTDIR}${CMAKE_INSTALL_FULL_BINDIR}/qs
	)
")

install(
	FILES ${CMAKE_SOURCE_DIR}/assets/org.quickshell.desktop
	DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
	FILES ${CMAKE_SOURCE_DIR}/assets/quickshell.svg
	DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps
	RENAME org.quickshell.svg
)

=== src/CMakeLists.txt ===
qt_add_executable(quickshell main.cpp)

install(TARGETS quickshell RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_subdirectory(build)
add_subdirectory(launch)
add_subdirectory(core)
add_subdirectory(debug)
add_subdirectory(ipc)
add_subdirectory(window)
add_subdirectory(io)
add_subdirectory(widgets)
add_subdirectory(ui)

if (CRASH_REPORTER)
	add_subdirectory(crash)
endif()

if (DBUS)
	add_subdirectory(dbus)
endif()

if (WAYLAND)
	add_subdirectory(wayland)
endif()

if (X11)
	add_subdirectory(x11)
endif()

add_subdirectory(services)

if (BLUETOOTH)
	add_subdirectory(bluetooth)
endif()

=== src/bluetooth/CMakeLists.txt ===
set_source_files_properties(org.bluez.Adapter.xml PROPERTIES
	CLASSNAME DBusBluezAdapterInterface
)

set_source_files_properties(org.bluez.Device.xml PROPERTIES
	CLASSNAME DBusBluezDeviceInterface
)

qt_add_dbus_interface(DBUS_INTERFACES
	org.bluez.Adapter.xml
	dbus_adapter
)

qt_add_dbus_interface(DBUS_INTERFACES
	org.bluez.Device.xml
	dbus_device
)

qt_add_library(quickshell-bluetooth STATIC
	adapter.cpp
	bluez.cpp
	device.cpp
	${DBUS_INTERFACES}
)

qt_add_qml_module(quickshell-bluetooth
	URI Quickshell.Bluetooth
	VERSION 0.1
	DEPENDENCIES QtQml
)

install_qml_module(quickshell-bluetooth)

# dbus headers
target_include_directories(quickshell-bluetooth PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(quickshell-bluetooth PRIVATE Qt::Qml Qt::DBus)
qs_add_link_dependencies(quickshell-bluetooth quickshell-dbus)

qs_module_pch(quickshell-bluetooth SET dbus)

target_link_libraries(quickshell PRIVATE quickshell-bluetoothplugin)

=== src/build/CMakeLists.txt ===
add_library(quickshell-build INTERFACE)

if (NOT DEFINED GIT_REVISION)
	execute_process(
		COMMAND git rev-parse HEAD
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		OUTPUT_VARIABLE GIT_REVISION
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
endif()

if (CRASH_REPORTER)
	set(CRASH_REPORTER_DEF 1)
else()
	set(CRASH_REPORTER_DEF 0)
endif()

if (DISTRIBUTOR_DEBUGINFO_AVAILABLE)
	set(DEBUGINFO_AVAILABLE 1)
else()
	set(DEBUGINFO_AVAILABLE 0)
endif()

configure_file(build.hpp.in build.hpp @ONLY ESCAPE_QUOTES)

target_include_directories(quickshell-build INTERFACE ${CMAKE_CURRENT_BINARY_DIR})

=== src/core/CMakeLists.txt ===
qt_add_library(quickshell-core STATIC
	plugin.cpp
	shell.cpp
	variants.cpp
	rootwrapper.cpp
	reload.cpp
	rootwrapper.cpp
	qmlglobal.cpp
	qmlscreen.cpp
	region.cpp
	persistentprops.cpp
	singleton.cpp
	generation.cpp
	scan.cpp
	qsintercept.cpp
	incubator.cpp
	lazyloader.cpp
	easingcurve.cpp
	iconimageprovider.cpp
	imageprovider.cpp
	transformwatcher.cpp
	boundcomponent.cpp
	model.cpp
	elapsedtimer.cpp
	desktopentry.cpp
	desktopentrymonitor.cpp
	objectrepeater.cpp
	platformmenu.cpp
	qsmenu.cpp
	retainable.cpp
	popupanchor.cpp
	types.cpp
	qsmenuanchor.cpp
	clock.cpp
	logging.cpp
	paths.cpp
	instanceinfo.cpp
	common.cpp
	iconprovider.cpp
	scriptmodel.cpp
	colorquantizer.cpp
	toolsupport.cpp
)

qt_add_qml_module(quickshell-core
	URI Quickshell
	VERSION 0.1
	DEPENDENCIES QtQuick
	OPTIONAL_IMPORTS Quickshell._Window
	DEFAULT_IMPORTS Quickshell._Window
)

install_qml_module(quickshell-core)

target_link_libraries(quickshell-core PRIVATE Qt::Quick Qt::Widgets)

qs_module_pch(quickshell-core SET large)

target_link_libraries(quickshell PRIVATE quickshell-coreplugin)

if (BUILD_TESTING)
	add_subdirectory(test)
endif()

=== src/crash/CMakeLists.txt ===
qt_add_library(quickshell-crash STATIC
	main.cpp
	interface.cpp
	handler.cpp
)

qs_pch(quickshell-crash SET large)

find_package(PkgConfig REQUIRED)
pkg_check_modules(breakpad REQUIRED IMPORTED_TARGET breakpad)
# only need client?? take only includes from pkg config todo
target_link_libraries(quickshell-crash PRIVATE PkgConfig::breakpad -lbreakpad_client)

# quick linked for pch compat
target_link_libraries(quickshell-crash PRIVATE quickshell-build Qt::Quick Qt::Widgets)

target_link_libraries(quickshell PRIVATE quickshell-crash)

=== src/dbus/CMakeLists.txt ===
set_source_files_properties(org.freedesktop.DBus.Properties.xml PROPERTIES
	CLASSNAME DBusPropertiesInterface
)

set_source_files_properties(org.freedesktop.DBus.ObjectManager.xml PROPERTIES
	CLASSNAME DBusObjectManagerInterface
	INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/dbus_objectmanager_types.hpp
)

qt_add_dbus_interface(DBUS_INTERFACES
	org.freedesktop.DBus.Properties.xml
	dbus_properties
)

qt_add_dbus_interface(DBUS_INTERFACES
	org.freedesktop.DBus.ObjectManager.xml
	dbus_objectmanager
)

qt_add_library(quickshell-dbus STATIC
	properties.cpp
	objectmanager.cpp
	bus.cpp
	${DBUS_INTERFACES}
)

# dbus headers
target_include_directories(quickshell-dbus PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(quickshell-dbus PRIVATE Qt::Core Qt::DBus)
# todo: link dbus to quickshell here instead of in modules that use it directly
# linker does not like this as is

qs_add_pchset(dbus
	DEPENDENCIES Qt::DBus
	HEADERS
		<QtDBus>
		<qdebug.h>
		<qdbusargument.h>
)

qs_pch(quickshell-dbus SET dbus)

add_subdirectory(dbusmenu)

=== src/debug/CMakeLists.txt ===
qt_add_library(quickshell-debug STATIC
	lint.cpp
)

qs_pch(quickshell-debug)
target_link_libraries(quickshell-debug PRIVATE Qt::Quick)
target_link_libraries(quickshell PRIVATE quickshell-debug)

=== src/io/CMakeLists.txt ===
qt_add_library(quickshell-io STATIC
	datastream.cpp
	processcore.cpp
	process.cpp
	fileview.cpp
	jsonadapter.cpp
	ipccomm.cpp
	ipc.cpp
	ipchandler.cpp
)

if (SOCKETS)
	target_sources(quickshell-io PRIVATE socket.cpp)
endif()

qt_add_qml_module(quickshell-io
	URI Quickshell.Io
	VERSION 0.1
	DEPENDENCIES QtQml
	QML_FILES
		FileView.qml
)

qs_add_module_deps_light(quickshell-io Quickshell)
install_qml_module(quickshell-io)

target_link_libraries(quickshell-io PRIVATE Qt::Quick)
target_link_libraries(quickshell PRIVATE quickshell-ioplugin)

qs_module_pch(quickshell-io)

if (BUILD_TESTING)
	add_subdirectory(test)
endif()

=== src/ipc/CMakeLists.txt ===
qt_add_library(quickshell-ipc STATIC
	ipc.cpp
)

qs_pch(quickshell-ipc)

target_link_libraries(quickshell-ipc PRIVATE Qt::Quick Qt::Network)

target_link_libraries(quickshell PRIVATE quickshell-ipc)

=== src/launch/CMakeLists.txt ===
find_package(CLI11 CONFIG REQUIRED)

qt_add_library(quickshell-launch STATIC
	parsecommand.cpp
	command.cpp
	launch.cpp
	main.cpp
)

target_link_libraries(quickshell-launch PRIVATE
	Qt::Quick Qt::Widgets CLI11::CLI11 quickshell-build
)

qs_add_pchset(launch
	DEPENDENCIES Qt::Core CLI11::CLI11
	HEADERS
		<CLI/App.hpp>
		<qcoreapplication.h>
)

qs_pch(quickshell-launch SET launch)

target_link_libraries(quickshell PRIVATE quickshell-launch)

=== src/services/CMakeLists.txt ===
if (SERVICE_STATUS_NOTIFIER)
	add_subdirectory(status_notifier)
endif()

if (SERVICE_PIPEWIRE)
	add_subdirectory(pipewire)
endif()

if (SERVICE_MPRIS)
	add_subdirectory(mpris)
endif()

if (SERVICE_PAM)
	add_subdirectory(pam)
endif()

if (SERVICE_GREETD)
	add_subdirectory(greetd)
endif()

if (SERVICE_UPOWER)
	add_subdirectory(upower)
endif()

if (SERVICE_NOTIFICATIONS)
	add_subdirectory(notifications)
endif()

=== debian/changelog ===
quickshell (0.2.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1129032)

 -- Michael Lloyd <michael@micl.dev>  Fri, 27 Feb 2026 12:54:57 +1100

=== debian/control ===
Source: quickshell
Section: x11
Priority: optional
Maintainer: Michael Lloyd <michael@micl.dev>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 pkgconf,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-wayland-dev,
 qt6-shadertools-dev,
 qt6-base-private-dev,
 qt6-declarative-private-dev,
 qt6-wayland-private-dev,
 libcli11-dev,
 libwayland-dev,
 wayland-protocols (>= 1.41),
 libpipewire-0.3-dev,
 libpam0g-dev,
 libdrm-dev,
 libgbm-dev,
 libjemalloc-dev,
 libegl-dev,
 libgles-dev,
 libxcb1-dev,
 spirv-tools
Standards-Version: 4.7.3
Homepage: https://quickshell.org/
Vcs-Browser: https://salsa.debian.org/micl/quickshell
Vcs-Git: https://salsa.debian.org/micl/quickshell.git

Package: quickshell
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 hicolor-icon-theme,
 qt6-svg-plugins,
 qml6-module-qtquick,
 qml6-module-qtquick-controls,
 qml6-module-qtquick-layouts
Description: flexible QtQuick-based desktop shell toolkit
 Quickshell is a toolkit for building status bars, widgets,
 lockscreens, and other desktop components using Qt6 and QtQuick.
 It supports both Wayland and X11, with integrations for PipeWire,
 MPRIS, system tray, PAM, Bluetooth, and compositor-specific
 features for Hyprland and Sway/i3. Configuration is done
 declaratively in QML with live hot-reloading.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DDISTRIBUTOR="Debian" \
		-DDISTRIBUTOR_DEBUGINFO_AVAILABLE=YES \
		-DCRASH_REPORTER=OFF \
		-DINSTALL_QML_PREFIX=lib/$(DEB_HOST_MULTIARCH)/qt6/qml

# Upstream test suite requires google-breakpad which is not packaged in Debian.
override_dh_auto_test:

=== debian/watch ===
Version: 5

Source: https://git.outfoxxed.me/api/v1/repos/quickshell/quickshell/tags
Matching-Pattern: https://git.outfoxxed.me/quickshell/quickshell/archive/v@ANY_VERSION@@ARCHIVE_EXT@
Search-Mode: plain
Filename-Mangle: s%.*/v@ANY_VERSION@%@PACKAGE@-$1%
